commit d61563f31ad33c93eae8e1c448475783c437f6e8
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Thu Jan 22 23:13:10 2026 +0000

    Tidying: pid string formatting

diff --git a/src/OS/unsupported/os.c-cygwin b/src/OS/unsupported/os.c-cygwin
index 56085b857..d9e54d6a8 100644
--- a/src/OS/unsupported/os.c-cygwin
+++ b/src/OS/unsupported/os.c-cygwin
@@ -55,7 +55,7 @@ int cygwin_setuid(uid_t uid )
   if (fakesetugid == 0) { 
     res = setuid(uid);
     if (cygwin_debug)
-      fprintf(stderr, "setuid %u %u %d pid: %d\n",
+      fprintf(stderr, "setuid %u %u %d pid: " PID_T_FMT "\n",
               uid, getuid(),res, getpid());
   }
   return res;
@@ -68,7 +68,7 @@ int cygwin_setgid(gid_t gid )
   if (fakesetugid == 0) { 
     res = setgid(gid);
     if (cygwin_debug)
-      fprintf(stderr, "setgid %u %u %d pid: %d\n",
+      fprintf(stderr, "setgid %u %u %d pid: " PID_T_FMT "\n",
               gid, getgid(), res, getpid());
   }
   return res;
diff --git a/src/src/auths/auth-spa.c b/src/src/auths/auth-spa.c
index ee69330dd..db62c6859 100644
--- a/src/src/auths/auth-spa.c
+++ b/src/src/auths/auth-spa.c
@@ -1407,7 +1407,7 @@ spa_build_auth_challenge(SPAAuthRequest * request, SPAAuthChallenge * challenge)
 {
 char chalstr[8];
 int i;
-int p = (int)getpid();
+pid_t p = getpid();
 int random_seed = (int)time(NULL) ^ ((p << 16) | p);
 
 /* Ensure challenge data is cleared, in case it isn't all used. This
diff --git a/src/src/auths/cram_md5.c b/src/src/auths/cram_md5.c
index 44b05465c..1532e2af6 100644
--- a/src/src/auths/cram_md5.c
+++ b/src/src/auths/cram_md5.c
@@ -173,8 +173,8 @@ int
 auth_cram_md5_server(auth_instance * ablock, uschar * data)
 {
 auth_cram_md5_options_block * ob = ablock->drinst.options_block;
-uschar * challenge = string_sprintf("<%d.%ld@%s>", getpid(),
-    (long int) time(NULL), primary_hostname);
+uschar * challenge = string_sprintf("<" PID_T_FMT ".%ld@%s>",
+    getpid(), (long int) time(NULL), primary_hostname);
 uschar * clear, * secret;
 uschar digest[16];
 int i, rc, len;
diff --git a/src/src/auths/dovecot.c b/src/src/auths/dovecot.c
index c9fdc0ea9..73322a6cd 100644
--- a/src/src/auths/dovecot.c
+++ b/src/src/auths/dovecot.c
@@ -441,7 +441,7 @@ Subsequently, the command was modified to add "secured" and "valid-client-
 cert" when relevant.
 ****************************************************************************/
 
-auth_command = string_sprintf("CPID\t%d\n"
+auth_command = string_sprintf("CPID\t" PID_T_FMT "\n"
        "AUTH\t%d\t%s\tservice=smtp\t%srip=%s\tlip=%s\tnologin\tresp=%s\n",
        getpid(), crequid,
        ablock->public_name, auth_extra_data, sender_host_address,
diff --git a/src/src/daemon.c b/src/src/daemon.c
index bce9bb9f4..d3e84a567 100644
--- a/src/src/daemon.c
+++ b/src/src/daemon.c
@@ -493,8 +493,8 @@ if (pid == 0)
   debug_selector = save_debug_selector;
 
   DEBUG(D_any)
-    debug_printf("Process %d is handling incoming connection from %s\n",
-      (int)getpid(), sender_fullhost);
+    debug_printf("Process " PID_T_FMT " is handling incoming connection"
+      " from %s\n", getpid(), sender_fullhost);
 
   /* Now disable debugging permanently if it's required only for the daemon
   process. */
@@ -538,7 +538,7 @@ if (pid == 0)
     reset_point = store_mark();   /* Save current store high water point */
 
     DEBUG(D_any)
-      debug_printf("Process %d is ready for new message\n", (int)getpid());
+      debug_printf("Process " PID_T_FMT " is ready for new message\n", getpid());
 
     /* Smtp_setup_msg() returns 0 on QUIT or if the call is from an
     unacceptable host or if an ACL "drop" command was triggered, -1 on
@@ -971,7 +971,7 @@ static BOOL
 operate_on_pid_file(const enum pid_op operation, const pid_t pid)
 {
 char pid_line[sizeof(int) * 3 + 2];
-const int pid_len = snprintf(pid_line, sizeof(pid_line), "%ld\n", (long)pid);
+const int pid_len = snprintf(pid_line, sizeof(pid_line), PID_T_FMT "\n", pid);
 BOOL lines_match = FALSE;
 uschar * path, * base, * dir;
 
@@ -1144,9 +1144,10 @@ daemon_client_sockname(struct sockaddr_un * sup, uschar ** sname)
 #ifdef EXIM_HAVE_ABSTRACT_UNIX_SOCKETS
 sup->sun_path[0] = 0;  /* Abstract local socket addr - Linux-specific? */
 return offsetof(struct sockaddr_un, sun_path) + 1
-  + snprintf(sup->sun_path+1, sizeof(sup->sun_path)-1, "exim_%d", getpid());
+  + snprintf(sup->sun_path+1, sizeof(sup->sun_path)-1,
+	      "exim_" PID_T_FMT, getpid());
 #else
-*sname = string_sprintf("%s/p_%d", spool_directory, getpid());
+*sname = string_sprintf("%s/p_" PID_T_FMT, spool_directory, getpid());
 return offsetof(struct sockaddr_un, sun_path)
   + snprintf(sup->sun_path, sizeof(sup->sun_path), "%s", CS *sname);
 #endif
@@ -2373,7 +2374,9 @@ if (f.running_in_test_harness || write_pid)
      || real_uid == root_uid
      || (real_uid == exim_uid && !override_pid_file_path)) ? PID_WRITE : PID_CHECK;
   if (!operate_on_pid_file(operation, getpid()))
-    DEBUG(D_any) debug_printf("%s pid file %s: %s\n", (operation == PID_WRITE) ? "write" : "check", pid_file_path, strerror(errno));
+    DEBUG(D_any) debug_printf("%s pid file %s: %s\n",
+			      operation == PID_WRITE ? "write" : "check",
+			      pid_file_path, strerror(errno));
   }
 
 /* Set up the handler for SIGHUP, which causes a restart of the daemon. */
@@ -2437,8 +2440,8 @@ if (f.inetd_wait_mode)
   else
     sprintf(CS p, "with no wait timeout");
 
-  log_write(0, LOG_MAIN,
-    "exim %s daemon started: pid=%ld, launched with listening socket, %s",
+  log_write(0, LOG_MAIN, "exim %s daemon started: pid=" PID_T_FMT
+			  ", launched with listening socket, %s",
     version_string, getpid(), big_buffer);
   set_process_info("daemon(%s): pre-listening socket", version_string);
 
@@ -2544,7 +2547,7 @@ else if (f.daemon_listen)
     }
 
   log_write(0, LOG_MAIN,
-    "exim %s daemon started: pid=%ld, %s, listening for %s",
+    "exim %s daemon started: pid=" PID_T_FMT ", %s, listening for %s",
     version_string, getpid(), qinfo, big_buffer);
   set_process_info("daemon(%s): %s, listening for %s",
     version_string, qinfo, big_buffer);
@@ -2554,7 +2557,7 @@ else	/* no listening sockets, only queue-runs */
   {
   const uschar * s = describe_queue_runners();
   log_write(0, LOG_MAIN,
-    "exim %s daemon started: pid=%ld, %s, not listening for SMTP",
+    "exim %s daemon started: pid=" PID_T_FMT ", %s, not listening for SMTP",
     version_string, getpid(), s);
   set_process_info("daemon(%s): %s, not listening", version_string, s);
   }
@@ -2859,7 +2862,7 @@ for (;;)
 
   if (sighup_seen)
     {
-    log_write(0, LOG_MAIN, "pid %ld: SIGHUP received: re-exec daemon",
+    log_write(0, LOG_MAIN, "pid " PID_T_FMT ": SIGHUP received: re-exec daemon",
       getpid());
     close_daemon_sockets(daemon_notifier_fd, fd_polls, listen_socket_count);
     unlink_notifier_socket();
@@ -2868,7 +2871,7 @@ for (;;)
     sighup_argv[0] = exim_path;
     exim_nullstd();
     execv(CS exim_path, (char *const *)sighup_argv);
-    log_write_die(0, LOG_MAIN, "pid %ld: exec of %s failed: %s",
+    log_write_die(0, LOG_MAIN, "pid " PID_T_FMT ": exec of %s failed: %s",
       getpid(), exim_path, strerror(errno));
     /*NOTREACHED*/
     }
diff --git a/src/src/deliver.c b/src/src/deliver.c
index a984ee21e..44e163fa4 100644
--- a/src/src/deliver.c
+++ b/src/src/deliver.c
@@ -2240,7 +2240,7 @@ if (  !shadowing
 
   addr->return_filename =
     spool_fname(US"msglog", message_subdir, message_id,
-      string_sprintf("-%ld-%d", (long)getpid(), return_count++));
+      string_sprintf("-" PID_T_FMT "-%d", getpid(), return_count++));
 
   if ((addr->return_file = open_msglog_file(addr->return_filename, 0400, &error)) < 0)
     {
@@ -5919,9 +5919,10 @@ if (!(bounce_recipient = addr_failed->prop.errors_address))
 /* Make a subprocess to send a message, using its stdin */
 
 if ((pid = child_open_exim(&fd, US"bounce-message")) < 0)
-  log_write_die(0, LOG_MAIN, "Process %ld (parent %ld) failed to "
+  log_write_die(0, LOG_MAIN,
+    "Process " PID_T_FMT " (parent " PID_T_FMT ") failed to "
     "create child process to send failure message: %s",
-    (long)getpid(), (long)getppid(), strerror(errno));
+    getpid(), getppid(), strerror(errno));
 
 /* Creation of child succeeded */
 
@@ -6577,9 +6578,10 @@ if (addr_senddsn)
 
   if (pid < 0)  /* Creation of child failed */
     {
-    log_write_die(0, LOG_MAIN, "Process %ld (parent %ld) failed to "
+    log_write_die(0, LOG_MAIN,
+      "Process " PID_T_FMT " (parent " PID_T_FMT ") failed to "
       "create child process to send success-dsn message: %s",
-      (long)getpid(), (long)getppid(), strerror(errno));
+      getpid(), getppid(), strerror(errno));
 
     DEBUG(D_deliver) debug_printf("DSN: child_open_exim failed\n");
     }
diff --git a/src/src/exim.c b/src/src/exim.c
index 5a756cc4d..a87219920 100644
--- a/src/src/exim.c
+++ b/src/src/exim.c
@@ -224,7 +224,7 @@ int len;
 uschar * s;
 va_list ap;
 
-g = string_fmt_append(&gs, "%5d ", (int)getpid());
+g = string_fmt_append(&gs, PID_T_FMT " ", getpid());
 len = gstring_length(g);
 va_start(ap, format);
 if (!string_vformat(g, 0, format, ap))
@@ -803,8 +803,8 @@ DEBUG(D_uid)
   {
   int group_count, save_errno;
   gid_t group_list[EXIM_GROUPLIST_SIZE];
-  debug_printf("changed uid/gid: %s\n  uid=%ld gid=%ld pid=%ld\n", msg,
-    (long int)geteuid(), (long int)getegid(), (long int)getpid());
+  debug_printf("changed uid/gid: %s\n  uid=%ld gid=%ld pid=" PID_T_FMT "\n",
+    msg, (long int)geteuid(), (long int)getegid(), getpid());
   group_count = getgroups(nelem(group_list), group_list);
   save_errno = errno;
   debug_printf("  auxiliary group list:");
@@ -840,9 +840,9 @@ smtp_fflush(SFF_NO_UNCORK);
 search_tidyup();
 store_exit();
 DEBUG(D_any)
-  debug_printf(">>>>>>>>>>>>>>>> Exim pid=%d (%s) terminating with rc=%d "
+  debug_printf(">>>>>>>>>>>>>>>> Exim pid=" PID_T_FMT " (%s) terminating with rc=%d "
     ">>>>>>>>>>>>>>>>\n",
-    (int)getpid(), process_purpose, rc);
+    getpid(), process_purpose, rc);
 exit(rc);
 }
 
@@ -852,9 +852,9 @@ exim_underbar_exit(int rc)
 {
 store_exit();
 DEBUG(D_any)
-  debug_printf(">>>>>>>>>>>>>>>> Exim pid=%d (%s) terminating with rc=%d "
+  debug_printf(">>>>>>>>>>>>>>>> Exim pid=" PID_T_FMT " (%s) terminating with rc=%d "
     ">>>>>>>>>>>>>>>>\n",
-    (int)getpid(), process_purpose, rc);
+    getpid(), process_purpose, rc);
 _exit(rc);
 }
 
diff --git a/src/src/exim_lock.c b/src/src/exim_lock.c
index f42da23a8..1797fa98b 100644
--- a/src/src/exim_lock.c
+++ b/src/src/exim_lock.c
@@ -305,7 +305,7 @@ if (use_lockfile)
 
   /* Presumably, this must match appendfile.c */
   sprintf(hitchname, "%s.%s.%08x.%08x", lockname, primary_hostname,
-    (unsigned int)now, (unsigned int)getpid());
+    (unsigned int)now, (unsigned long)getpid());
 
   if (verbose)
     printf("exim_lock: lockname =  %s\n           hitchname = %s\n", lockname,
diff --git a/src/src/expand.c b/src/src/expand.c
index 5e46f7cde..097e4aa5e 100644
--- a/src/src/expand.c
+++ b/src/src/expand.c
@@ -2004,7 +2004,7 @@ switch (vp->type)
     return (s = *((uschar **)(val))) ? s : US"";
 
   case vtype_pid:
-    sprintf(CS var_buffer, "%d", (int)getpid()); /* pid */
+    sprintf(CS var_buffer, PID_T_FMT, getpid()); /* pid */
     return var_buffer;
 
   case vtype_load_avg:
diff --git a/src/src/functions.h b/src/src/functions.h
index 0981f126b..916c1a329 100644
--- a/src/src/functions.h
+++ b/src/src/functions.h
@@ -1311,8 +1311,8 @@ report_time_since(const struct timeval * t0, const uschar * where)
 # ifdef MEASURE_TIMING
 struct timeval diff;
 timesince(&diff, t0);
-fprintf(stderr, "%d %s:\t%ld.%06ld\n",
-       (uint)getpid(), where, (long)diff.tv_sec, (long)diff.tv_usec);
+fprintf(stderr, PID_T_FMT " %s:\t%ld.%06ld\n",
+       getpid(), where, (long)diff.tv_sec, (long)diff.tv_usec);
 # endif
 }
 
@@ -1405,7 +1405,7 @@ the generator for it at any time. */
 static inline void
 set_connection_id(void)
 {
-connection_id = string_sprintf("%lu", (u_long)getpid());
+connection_id = string_sprintf(PID_T_FMT, getpid());
 }
 
 
diff --git a/src/src/host.c b/src/src/host.c
index 130334793..1bafda996 100644
--- a/src/src/host.c
+++ b/src/src/host.c
@@ -94,7 +94,7 @@ if (random_seed == 0)
     random_seed = 42;
   else
     {
-    int p = (int)getpid();
+    pid_t p = getpid();
     random_seed = (int)time(NULL) ^ ((p << 16) | p);
     }
 random_seed = 1103515245 * random_seed + 12345;
diff --git a/src/src/log.c b/src/src/log.c
index 46d8873da..e4fd3aa7f 100644
--- a/src/src/log.c
+++ b/src/src/log.c
@@ -1023,7 +1023,7 @@ string_fmt_append_noextend(&gs, "%s ", tod_stamp(tod_log));
 if (LOGGING(pid))
   {
   if (!syslog_pid) pid_position[0] = gstring_length(g);	/* remember begin … */
-  string_fmt_append_noextend(g, "[%ld] ", (long)getpid());
+  string_fmt_append_noextend(g, "[" PID_T_FMT "] ", getpid());
   if (!syslog_pid) pid_position[1] = gstring_length(g);	/*  … and end+1 of the PID */
   }
 
diff --git a/src/src/miscmods/dkim_transport.c b/src/src/miscmods/dkim_transport.c
index 5bce81ad1..1e9a1153c 100644
--- a/src/src/miscmods/dkim_transport.c
+++ b/src/src/miscmods/dkim_transport.c
@@ -264,7 +264,7 @@ off_t k_file_size;
 const uschar * errstr;
 
 dkim_spool_name = spool_fname(US"input", message_subdir, message_id,
-		    string_sprintf("-%d-K", (int)getpid()));
+		    string_sprintf("-" PID_T_FMT "-K", getpid()));
 
 DEBUG(D_transport) debug_printf("dkim signing via file %s\n", dkim_spool_name);
 
diff --git a/src/src/transports/appendfile.c b/src/src/transports/appendfile.c
index cad14b889..59af24ced 100644
--- a/src/src/transports/appendfile.c
+++ b/src/src/transports/appendfile.c
@@ -1564,7 +1564,7 @@ if (!isdirectory)
     /* cf. exim_lock.c */
     lockname = string_sprintf("%s.lock", filename);
     hitchname = string_sprintf( "%s.%s.%08x.%08x", lockname, primary_hostname,
-      (unsigned int)(time(NULL)), (unsigned int)getpid());
+      (unsigned int)(time(NULL)), (unsigned long)getpid());
 
     DEBUG(D_transport) debug_printf("lock name: %s\nhitch name: %s\n", lockname,
       hitchname);
@@ -2419,8 +2419,8 @@ else
     {
     DEBUG(D_transport)
       debug_printf("delivering to new file in %s\n", path);
-    filename = dataname =
-      string_sprintf("%s/temp.%d.%s", path, (int)getpid(), primary_hostname);
+    filename = dataname = string_sprintf("%s/temp." PID_T_FMT ".%s",
+					path, getpid(), primary_hostname);
     fd = Uopen(filename, O_WRONLY|O_CREAT, mode);
     if (fd < 0 &&                                 /* failed to open, and */
         (errno != ENOENT ||                       /* either not non-exist */
diff --git a/src/src/transports/tf_maildir.c b/src/src/transports/tf_maildir.c
index 60716f1a8..fdbe01e71 100644
--- a/src/src/transports/tf_maildir.c
+++ b/src/src/transports/tf_maildir.c
@@ -527,8 +527,8 @@ else
     FALSE);
 
   (void)gettimeofday(&tv, NULL);
-  tempname = string_sprintf("%s/tmp/" TIME_T_FMT ".H%luP%lu.%s",
-    path, tv.tv_sec, tv.tv_usec, (long unsigned) getpid(), primary_hostname);
+  tempname = string_sprintf("%s/tmp/" TIME_T_FMT ".H%luP" PID_T_FMT ".%s",
+    path, tv.tv_sec, tv.tv_usec, getpid(), primary_hostname);
 
   fd = Uopen(tempname, O_RDWR|O_CREAT|O_EXCL, ob->mode ? ob->mode : 0600);
   if (fd >= 0)

